//
//  main.swift
//  Connect4_CLI
//
//  Created by Adam BONAFOS on 13/01/2025.
//

import Foundation
import Model

print("Connect4")

func read(question: String) -> String {
    print(question)
    let answer = readLine()
    if let answer {
        return answer
    } else {
        return ""
    }
}

public func display(board: Board) {
        var boardString = ""

    for row in (0..<board.rowNb).reversed() {
        for column in 0..<board.columnNb {
            let token = board[row, column]
                let emoji: String
                switch token {
                case .red:
                    emoji = "🔴"  // Rond rouge
                case .yellow:
                    emoji = "🟡"  // Rond jaune
                case .empty:
                    emoji = "⚪"  // Rond gris (vide)
                }
                boardString += emoji + " "
            }
            boardString += "\n" // Nouvelle ligne après chaque ligne de la grille
        }
        print(boardString)
    }

var rules = Connect4Rules(piecesToAlign: 4)
var player1: Player = HumanPlayer(rules: rules, color: .red, name: "Adam", CLI: read)
var player2: Player = RandomPlayer(rules: rules, color: .yellow, name: "BOT")
var players = [player1, player2]
var currentPlayer: Player

var game = Game(rules: rules, players: players)
game.start(display: display)
